#ifndef topcell_INCLUDED_
#define topcell_INCLUDED_

#include <systemc>

#include "fifo_gen.h"
#include "fifo_signals.h"
#include "fifo_writer.h"

SC_MODULE(topcell)
{
    soclib::caba::FifoGen fifo_gen;
    soclib::caba::FifoWriter<sc_dt::sc_uint<8>  >  fifo_writer;
    soclib::caba::FifoSignals<sc_dt::sc_uint<8> >  fifo;

  public:
    sc_core::sc_in<bool> p_clock;
    sc_core::sc_in<bool> p_resetn;

    topcell(sc_core::sc_module_name name);
};

#endif
